# Copyright 2019 the V8 project authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can
# be found in the LICENSE file.

# This file is automatically generated by mkgrokdump and should not
# be modified manually.

# List of known V8 instance types.
INSTANCE_TYPES = {
  0: "INTERNALIZED_STRING_TYPE",
  2: "EXTERNAL_INTERNALIZED_STRING_TYPE",
  8: "ONE_BYTE_INTERNALIZED_STRING_TYPE",
  10: "EXTERNAL_ONE_BYTE_INTERNALIZED_STRING_TYPE",
  18: "UNCACHED_EXTERNAL_INTERNALIZED_STRING_TYPE",
  26: "UNCACHED_EXTERNAL_ONE_BYTE_INTERNALIZED_STRING_TYPE",
  32: "STRING_TYPE",
  33: "CONS_STRING_TYPE",
  34: "EXTERNAL_STRING_TYPE",
  35: "SLICED_STRING_TYPE",
  37: "THIN_STRING_TYPE",
  40: "ONE_BYTE_STRING_TYPE",
  41: "CONS_ONE_BYTE_STRING_TYPE",
  42: "EXTERNAL_ONE_BYTE_STRING_TYPE",
  43: "SLICED_ONE_BYTE_STRING_TYPE",
  45: "THIN_ONE_BYTE_STRING_TYPE",
  50: "UNCACHED_EXTERNAL_STRING_TYPE",
  58: "UNCACHED_EXTERNAL_ONE_BYTE_STRING_TYPE",
  64: "SYMBOL_TYPE",
  65: "BIG_INT_BASE_TYPE",
  66: "HEAP_NUMBER_TYPE",
  67: "ODDBALL_TYPE",
  68: "ABSTRACT_INTERNAL_CLASS_SUBCLASS1_TYPE",
  69: "ABSTRACT_INTERNAL_CLASS_SUBCLASS2_TYPE",
  70: "FOREIGN_TYPE",
  71: "WASM_FUNCTION_DATA_TYPE",
  72: "WASM_CAPI_FUNCTION_DATA_TYPE",
  73: "WASM_EXPORTED_FUNCTION_DATA_TYPE",
  74: "WASM_JS_FUNCTION_DATA_TYPE",
  75: "WASM_TYPE_INFO_TYPE",
  76: "PROMISE_FULFILL_REACTION_JOB_TASK_TYPE",
  77: "PROMISE_REJECT_REACTION_JOB_TASK_TYPE",
  78: "CALLABLE_TASK_TYPE",
  79: "CALLBACK_TASK_TYPE",
  80: "PROMISE_RESOLVE_THENABLE_JOB_TASK_TYPE",
  81: "LOAD_HANDLER_TYPE",
  82: "STORE_HANDLER_TYPE",
  83: "FUNCTION_TEMPLATE_INFO_TYPE",
  84: "OBJECT_TEMPLATE_INFO_TYPE",
  85: "ACCESS_CHECK_INFO_TYPE",
  86: "ACCESSOR_INFO_TYPE",
  87: "ACCESSOR_PAIR_TYPE",
  88: "ALIASED_ARGUMENTS_ENTRY_TYPE",
  89: "ALLOCATION_MEMENTO_TYPE",
  90: "ALLOCATION_SITE_TYPE",
  91: "ARRAY_BOILERPLATE_DESCRIPTION_TYPE",
  92: "ASM_WASM_DATA_TYPE",
  93: "ASYNC_GENERATOR_REQUEST_TYPE",
  94: "BREAK_POINT_TYPE",
  95: "BREAK_POINT_INFO_TYPE",
  96: "CACHED_TEMPLATE_OBJECT_TYPE",
  97: "CALL_HANDLER_INFO_TYPE",
  98: "CLASS_POSITIONS_TYPE",
  99: "DEBUG_INFO_TYPE",
  100: "ENUM_CACHE_TYPE",
  101: "FEEDBACK_CELL_TYPE",
  102: "FUNCTION_TEMPLATE_RARE_DATA_TYPE",
  103: "INTERCEPTOR_INFO_TYPE",
  104: "INTERPRETER_DATA_TYPE",
  105: "MODULE_REQUEST_TYPE",
  106: "PROMISE_CAPABILITY_TYPE",
  107: "PROMISE_REACTION_TYPE",
  108: "PROPERTY_DESCRIPTOR_OBJECT_TYPE",
  109: "PROTOTYPE_INFO_TYPE",
  110: "REG_EXP_BOILERPLATE_DESCRIPTION_TYPE",
  111: "SCRIPT_TYPE",
  112: "SCRIPT_OR_MODULE_TYPE",
  113: "SOURCE_TEXT_MODULE_INFO_ENTRY_TYPE",
  114: "STACK_FRAME_INFO_TYPE",
  115: "TEMPLATE_OBJECT_DESCRIPTION_TYPE",
  116: "TUPLE2_TYPE",
  117: "WASM_CONTINUATION_OBJECT_TYPE",
  118: "WASM_EXCEPTION_TAG_TYPE",
  119: "WASM_INDIRECT_FUNCTION_TABLE_TYPE",
  120: "FIXED_ARRAY_TYPE",
  121: "HASH_TABLE_TYPE",
  122: "EPHEMERON_HASH_TABLE_TYPE",
  123: "GLOBAL_DICTIONARY_TYPE",
  124: "NAME_DICTIONARY_TYPE",
  125: "NUMBER_DICTIONARY_TYPE",
  126: "ORDERED_HASH_MAP_TYPE",
  127: "ORDERED_HASH_SET_TYPE",
  128: "ORDERED_NAME_DICTIONARY_TYPE",
  129: "SIMPLE_NUMBER_DICTIONARY_TYPE",
  130: "CLOSURE_FEEDBACK_CELL_ARRAY_TYPE",
  131: "OBJECT_BOILERPLATE_DESCRIPTION_TYPE",
  132: "SCRIPT_CONTEXT_TABLE_TYPE",
  133: "BYTE_ARRAY_TYPE",
  134: "BYTECODE_ARRAY_TYPE",
  135: "FIXED_DOUBLE_ARRAY_TYPE",
  136: "INTERNAL_CLASS_WITH_SMI_ELEMENTS_TYPE",
  137: "SLOPPY_ARGUMENTS_ELEMENTS_TYPE",
  138: "AWAIT_CONTEXT_TYPE",
  139: "BLOCK_CONTEXT_TYPE",
  140: "CATCH_CONTEXT_TYPE",
  141: "DEBUG_EVALUATE_CONTEXT_TYPE",
  142: "EVAL_CONTEXT_TYPE",
  143: "FUNCTION_CONTEXT_TYPE",
  144: "MODULE_CONTEXT_TYPE",
  145: "NATIVE_CONTEXT_TYPE",
  146: "SCRIPT_CONTEXT_TYPE",
  147: "WITH_CONTEXT_TYPE",
  148: "EXPORTED_SUB_CLASS_BASE_TYPE",
  149: "EXPORTED_SUB_CLASS_TYPE",
  150: "EXPORTED_SUB_CLASS2_TYPE",
  151: "SMALL_ORDERED_HASH_MAP_TYPE",
  152: "SMALL_ORDERED_HASH_SET_TYPE",
  153: "SMALL_ORDERED_NAME_DICTIONARY_TYPE",
  154: "DESCRIPTOR_ARRAY_TYPE",
  155: "STRONG_DESCRIPTOR_ARRAY_TYPE",
  156: "SOURCE_TEXT_MODULE_TYPE",
  157: "SYNTHETIC_MODULE_TYPE",
  158: "UNCOMPILED_DATA_WITH_PREPARSE_DATA_TYPE",
  159: "UNCOMPILED_DATA_WITHOUT_PREPARSE_DATA_TYPE",
  160: "WEAK_FIXED_ARRAY_TYPE",
  161: "TRANSITION_ARRAY_TYPE",
  162: "CALL_REF_DATA_TYPE",
  163: "CELL_TYPE",
  164: "CODE_TYPE",
  165: "CODE_DATA_CONTAINER_TYPE",
  166: "COVERAGE_INFO_TYPE",
  167: "EMBEDDER_DATA_ARRAY_TYPE",
  168: "FEEDBACK_METADATA_TYPE",
  169: "FEEDBACK_VECTOR_TYPE",
  170: "FILLER_TYPE",
  171: "FREE_SPACE_TYPE",
  172: "INTERNAL_CLASS_TYPE",
  173: "INTERNAL_CLASS_WITH_STRUCT_ELEMENTS_TYPE",
  174: "MAP_TYPE",
  175: "MEGA_DOM_HANDLER_TYPE",
  176: "ON_HEAP_BASIC_BLOCK_PROFILER_DATA_TYPE",
  177: "PREPARSE_DATA_TYPE",
  178: "PROPERTY_ARRAY_TYPE",
  179: "PROPERTY_CELL_TYPE",
  180: "SCOPE_INFO_TYPE",
  181: "SHARED_FUNCTION_INFO_TYPE",
  182: "SMI_BOX_TYPE",
  183: "SMI_PAIR_TYPE",
  184: "SORT_STATE_TYPE",
  185: "SWISS_NAME_DICTIONARY_TYPE",
  186: "WEAK_ARRAY_LIST_TYPE",
  187: "WEAK_CELL_TYPE",
  188: "WASM_ARRAY_TYPE",
  189: "WASM_STRUCT_TYPE",
  190: "JS_PROXY_TYPE",
  1057: "JS_OBJECT_TYPE",
  191: "JS_GLOBAL_OBJECT_TYPE",
  192: "JS_GLOBAL_PROXY_TYPE",
  193: "JS_MODULE_NAMESPACE_TYPE",
  1040: "JS_SPECIAL_API_OBJECT_TYPE",
  1041: "JS_PRIMITIVE_WRAPPER_TYPE",
  1058: "JS_API_OBJECT_TYPE",
  2058: "JS_LAST_DUMMY_API_OBJECT_TYPE",
  2059: "JS_BOUND_FUNCTION_TYPE",
  2060: "JS_FUNCTION_TYPE",
  2061: "BIGINT64_TYPED_ARRAY_CONSTRUCTOR_TYPE",
  2062: "BIGUINT64_TYPED_ARRAY_CONSTRUCTOR_TYPE",
  2063: "FLOAT32_TYPED_ARRAY_CONSTRUCTOR_TYPE",
  2064: "FLOAT64_TYPED_ARRAY_CONSTRUCTOR_TYPE",
  2065: "INT16_TYPED_ARRAY_CONSTRUCTOR_TYPE",
  2066: "INT32_TYPED_ARRAY_CONSTRUCTOR_TYPE",
  2067: "INT8_TYPED_ARRAY_CONSTRUCTOR_TYPE",
  2068: "UINT16_TYPED_ARRAY_CONSTRUCTOR_TYPE",
  2069: "UINT32_TYPED_ARRAY_CONSTRUCTOR_TYPE",
  2070: "UINT8_CLAMPED_TYPED_ARRAY_CONSTRUCTOR_TYPE",
  2071: "UINT8_TYPED_ARRAY_CONSTRUCTOR_TYPE",
  2072: "JS_ARRAY_CONSTRUCTOR_TYPE",
  2073: "JS_PROMISE_CONSTRUCTOR_TYPE",
  2074: "JS_REG_EXP_CONSTRUCTOR_TYPE",
  2075: "JS_CLASS_CONSTRUCTOR_TYPE",
  2076: "JS_ARRAY_ITERATOR_PROTOTYPE_TYPE",
  2077: "JS_ITERATOR_PROTOTYPE_TYPE",
  2078: "JS_MAP_ITERATOR_PROTOTYPE_TYPE",
  2079: "JS_OBJECT_PROTOTYPE_TYPE",
  2080: "JS_PROMISE_PROTOTYPE_TYPE",
  2081: "JS_REG_EXP_PROTOTYPE_TYPE",
  2082: "JS_SET_ITERATOR_PROTOTYPE_TYPE",
  2083: "JS_SET_PROTOTYPE_TYPE",
  2084: "JS_STRING_ITERATOR_PROTOTYPE_TYPE",
  2085: "JS_TYPED_ARRAY_PROTOTYPE_TYPE",
  2086: "JS_MAP_KEY_ITERATOR_TYPE",
  2087: "JS_MAP_KEY_VALUE_ITERATOR_TYPE",
  2088: "JS_MAP_VALUE_ITERATOR_TYPE",
  2089: "JS_SET_KEY_VALUE_ITERATOR_TYPE",
  2090: "JS_SET_VALUE_ITERATOR_TYPE",
  2091: "JS_GENERATOR_OBJECT_TYPE",
  2092: "JS_ASYNC_FUNCTION_OBJECT_TYPE",
  2093: "JS_ASYNC_GENERATOR_OBJECT_TYPE",
  2094: "JS_DATA_VIEW_TYPE",
  2095: "JS_TYPED_ARRAY_TYPE",
  2096: "JS_MAP_TYPE",
  2097: "JS_SET_TYPE",
  2098: "JS_WEAK_MAP_TYPE",
  2099: "JS_WEAK_SET_TYPE",
  2100: "JS_ARGUMENTS_OBJECT_TYPE",
  2101: "JS_ARRAY_TYPE",
  2102: "JS_ARRAY_BUFFER_TYPE",
  2103: "JS_ARRAY_ITERATOR_TYPE",
  2104: "JS_ASYNC_FROM_SYNC_ITERATOR_TYPE",
  2105: "JS_COLLATOR_TYPE",
  2106: "JS_CONTEXT_EXTENSION_OBJECT_TYPE",
  2107: "JS_DATE_TYPE",
  2108: "JS_DATE_TIME_FORMAT_TYPE",
  2109: "JS_DISPLAY_NAMES_TYPE",
  2110: "JS_ERROR_TYPE",
  2111: "JS_FINALIZATION_REGISTRY_TYPE",
  2112: "JS_LIST_FORMAT_TYPE",
  2113: "JS_LOCALE_TYPE",
  2114: "JS_MESSAGE_OBJECT_TYPE",
  2115: "JS_NUMBER_FORMAT_TYPE",
  2116: "JS_PLURAL_RULES_TYPE",
  2117: "JS_PROMISE_TYPE",
  2118: "JS_REG_EXP_TYPE",
  2119: "JS_REG_EXP_STRING_ITERATOR_TYPE",
  2120: "JS_RELATIVE_TIME_FORMAT_TYPE",
  2121: "JS_SEGMENT_ITERATOR_TYPE",
  2122: "JS_SEGMENTER_TYPE",
  2123: "JS_SEGMENTS_TYPE",
  2124: "JS_STRING_ITERATOR_TYPE",
  2125: "JS_TEMPORAL_CALENDAR_TYPE",
  2126: "JS_TEMPORAL_DURATION_TYPE",
  2127: "JS_TEMPORAL_INSTANT_TYPE",
  2128: "JS_TEMPORAL_PLAIN_DATE_TYPE",
  2129: "JS_TEMPORAL_PLAIN_DATE_TIME_TYPE",
  2130: "JS_TEMPORAL_PLAIN_MONTH_DAY_TYPE",
  2131: "JS_TEMPORAL_PLAIN_TIME_TYPE",
  2132: "JS_TEMPORAL_PLAIN_YEAR_MONTH_TYPE",
  2133: "JS_TEMPORAL_TIME_ZONE_TYPE",
  2134: "JS_TEMPORAL_ZONED_DATE_TIME_TYPE",
  2135: "JS_V8_BREAK_ITERATOR_TYPE",
  2136: "JS_WEAK_REF_TYPE",
  2137: "WASM_GLOBAL_OBJECT_TYPE",
  2138: "WASM_INSTANCE_OBJECT_TYPE",
  2139: "WASM_MEMORY_OBJECT_TYPE",
  2140: "WASM_MODULE_OBJECT_TYPE",
  2141: "WASM_TABLE_OBJECT_TYPE",
  2142: "WASM_TAG_OBJECT_TYPE",
  2143: "WASM_VALUE_OBJECT_TYPE",
}

# List of known V8 maps.
KNOWN_MAPS = {
  ("read_only_space", 0x02119): (174, "MetaMap"),
  ("read_only_space", 0x02141): (67, "NullMap"),
  ("read_only_space", 0x02169): (155, "StrongDescriptorArrayMap"),
  ("read_only_space", 0x02191): (160, "WeakFixedArrayMap"),
  ("read_only_space", 0x021d1): (100, "EnumCacheMap"),
  ("read_only_space", 0x02205): (120, "FixedArrayMap"),
  ("read_only_space", 0x02251): (8, "OneByteInternalizedStringMap"),
  ("read_only_space", 0x0229d): (171, "FreeSpaceMap"),
  ("read_only_space", 0x022c5): (170, "OnePointerFillerMap"),
  ("read_only_space", 0x022ed): (170, "TwoPointerFillerMap"),
  ("read_only_space", 0x02315): (67, "UninitializedMap"),
  ("read_only_space", 0x0238d): (67, "UndefinedMap"),
  ("read_only_space", 0x023d1): (66, "HeapNumberMap"),
  ("read_only_space", 0x02405): (67, "TheHoleMap"),
  ("read_only_space", 0x02465): (67, "BooleanMap"),
  ("read_only_space", 0x02509): (133, "ByteArrayMap"),
  ("read_only_space", 0x02531): (120, "FixedCOWArrayMap"),
  ("read_only_space", 0x02559): (121, "HashTableMap"),
  ("read_only_space", 0x02581): (64, "SymbolMap"),
  ("read_only_space", 0x025a9): (40, "OneByteStringMap"),
  ("read_only_space", 0x025d1): (180, "ScopeInfoMap"),
  ("read_only_space", 0x025f9): (181, "SharedFunctionInfoMap"),
  ("read_only_space", 0x02621): (164, "CodeMap"),
  ("read_only_space", 0x02649): (163, "CellMap"),
  ("read_only_space", 0x02671): (179, "GlobalPropertyCellMap"),
  ("read_only_space", 0x02699): (70, "ForeignMap"),
  ("read_only_space", 0x026c1): (161, "TransitionArrayMap"),
  ("read_only_space", 0x026e9): (45, "ThinOneByteStringMap"),
  ("read_only_space", 0x02711): (169, "FeedbackVectorMap"),
  ("read_only_space", 0x02749): (67, "ArgumentsMarkerMap"),
  ("read_only_space", 0x027a9): (67, "ExceptionMap"),
  ("read_only_space", 0x02805): (67, "TerminationExceptionMap"),
  ("read_only_space", 0x0286d): (67, "OptimizedOutMap"),
  ("read_only_space", 0x028cd): (67, "StaleRegisterMap"),
  ("read_only_space", 0x0292d): (132, "ScriptContextTableMap"),
  ("read_only_space", 0x02955): (130, "ClosureFeedbackCellArrayMap"),
  ("read_only_space", 0x0297d): (168, "FeedbackMetadataArrayMap"),
  ("read_only_space", 0x029a5): (120, "ArrayListMap"),
  ("read_only_space", 0x029cd): (65, "BigIntMap"),
  ("read_only_space", 0x029f5): (131, "ObjectBoilerplateDescriptionMap"),
  ("read_only_space", 0x02a1d): (134, "BytecodeArrayMap"),
  ("read_only_space", 0x02a45): (165, "CodeDataContainerMap"),
  ("read_only_space", 0x02a6d): (166, "CoverageInfoMap"),
  ("read_only_space", 0x02a95): (135, "FixedDoubleArrayMap"),
  ("read_only_space", 0x02abd): (123, "GlobalDictionaryMap"),
  ("read_only_space", 0x02ae5): (101, "ManyClosuresCellMap"),
  ("read_only_space", 0x02b0d): (175, "MegaDomHandlerMap"),
  ("read_only_space", 0x02b35): (120, "ModuleInfoMap"),
  ("read_only_space", 0x02b5d): (124, "NameDictionaryMap"),
  ("read_only_space", 0x02b85): (101, "NoClosuresCellMap"),
  ("read_only_space", 0x02bad): (125, "NumberDictionaryMap"),
  ("read_only_space", 0x02bd5): (101, "OneClosureCellMap"),
  ("read_only_space", 0x02bfd): (126, "OrderedHashMapMap"),
  ("read_only_space", 0x02c25): (127, "OrderedHashSetMap"),
  ("read_only_space", 0x02c4d): (128, "OrderedNameDictionaryMap"),
  ("read_only_space", 0x02c75): (177, "PreparseDataMap"),
  ("read_only_space", 0x02c9d): (178, "PropertyArrayMap"),
  ("read_only_space", 0x02cc5): (97, "SideEffectCallHandlerInfoMap"),
  ("read_only_space", 0x02ced): (97, "SideEffectFreeCallHandlerInfoMap"),
  ("read_only_space", 0x02d15): (97, "NextCallSideEffectFreeCallHandlerInfoMap"),
  ("read_only_space", 0x02d3d): (129, "SimpleNumberDictionaryMap"),
  ("read_only_space", 0x02d65): (151, "SmallOrderedHashMapMap"),
  ("read_only_space", 0x02d8d): (152, "SmallOrderedHashSetMap"),
  ("read_only_space", 0x02db5): (153, "SmallOrderedNameDictionaryMap"),
  ("read_only_space", 0x02ddd): (156, "SourceTextModuleMap"),
  ("read_only_space", 0x02e05): (185, "SwissNameDictionaryMap"),
  ("read_only_space", 0x02e2d): (157, "SyntheticModuleMap"),
  ("read_only_space", 0x02e55): (72, "WasmCapiFunctionDataMap"),
  ("read_only_space", 0x02e7d): (73, "WasmExportedFunctionDataMap"),
  ("read_only_space", 0x02ea5): (74, "WasmJSFunctionDataMap"),
  ("read_only_space", 0x02ecd): (75, "WasmTypeInfoMap"),
  ("read_only_space", 0x02ef5): (186, "WeakArrayListMap"),
  ("read_only_space", 0x02f1d): (122, "EphemeronHashTableMap"),
  ("read_only_space", 0x02f45): (167, "EmbedderDataArrayMap"),
  ("read_only_space", 0x02f6d): (187, "WeakCellMap"),
  ("read_only_space", 0x02f95): (32, "StringMap"),
  ("read_only_space", 0x02fbd): (41, "ConsOneByteStringMap"),
  ("read_only_space", 0x02fe5): (33, "ConsStringMap"),
  ("read_only_space", 0x0300d): (37, "ThinStringMap"),
  ("read_only_space", 0x03035): (35, "SlicedStringMap"),
  ("read_only_space", 0x0305d): (43, "SlicedOneByteStringMap"),
  ("read_only_space", 0x03085): (34, "ExternalStringMap"),
  ("read_only_space", 0x030ad): (42, "ExternalOneByteStringMap"),
  ("read_only_space", 0x030d5): (50, "UncachedExternalStringMap"),
  ("read_only_space", 0x030fd): (0, "InternalizedStringMap"),
  ("read_only_space", 0x03125): (2, "ExternalInternalizedStringMap"),
  ("read_only_space", 0x0314d): (10, "ExternalOneByteInternalizedStringMap"),
  ("read_only_space", 0x03175): (18, "UncachedExternalInternalizedStringMap"),
  ("read_only_space", 0x0319d): (26, "UncachedExternalOneByteInternalizedStringMap"),
  ("read_only_space", 0x031c5): (58, "UncachedExternalOneByteStringMap"),
  ("read_only_space", 0x031ed): (67, "SelfReferenceMarkerMap"),
  ("read_only_space", 0x03215): (67, "BasicBlockCountersMarkerMap"),
  ("read_only_space", 0x03259): (91, "ArrayBoilerplateDescriptionMap"),
  ("read_only_space", 0x03359): (103, "InterceptorInfoMap"),
  ("read_only_space", 0x05bed): (76, "PromiseFulfillReactionJobTaskMap"),
  ("read_only_space", 0x05c15): (77, "PromiseRejectReactionJobTaskMap"),
  ("read_only_space", 0x05c3d): (78, "CallableTaskMap"),
  ("read_only_space", 0x05c65): (79, "CallbackTaskMap"),
  ("read_only_space", 0x05c8d): (80, "PromiseResolveThenableJobTaskMap"),
  ("read_only_space", 0x05cb5): (83, "FunctionTemplateInfoMap"),
  ("read_only_space", 0x05cdd): (84, "ObjectTemplateInfoMap"),
  ("read_only_space", 0x05d05): (85, "AccessCheckInfoMap"),
  ("read_only_space", 0x05d2d): (86, "AccessorInfoMap"),
  ("read_only_space", 0x05d55): (87, "AccessorPairMap"),
  ("read_only_space", 0x05d7d): (88, "AliasedArgumentsEntryMap"),
  ("read_only_space", 0x05da5): (89, "AllocationMementoMap"),
  ("read_only_space", 0x05dcd): (92, "AsmWasmDataMap"),
  ("read_only_space", 0x05df5): (93, "AsyncGeneratorRequestMap"),
  ("read_only_space", 0x05e1d): (94, "BreakPointMap"),
  ("read_only_space", 0x05e45): (95, "BreakPointInfoMap"),
  ("read_only_space", 0x05e6d): (96, "CachedTemplateObjectMap"),
  ("read_only_space", 0x05e95): (98, "ClassPositionsMap"),
  ("read_only_space", 0x05ebd): (99, "DebugInfoMap"),
  ("read_only_space", 0x05ee5): (102, "FunctionTemplateRareDataMap"),
  ("read_only_space", 0x05f0d): (104, "InterpreterDataMap"),
  ("read_only_space", 0x05f35): (105, "ModuleRequestMap"),
  ("read_only_space", 0x05f5d): (106, "PromiseCapabilityMap"),
  ("read_only_space", 0x05f85): (107, "PromiseReactionMap"),
  ("read_only_space", 0x05fad): (108, "PropertyDescriptorObjectMap"),
  ("read_only_space", 0x05fd5): (109, "PrototypeInfoMap"),
  ("read_only_space", 0x05ffd): (110, "RegExpBoilerplateDescriptionMap"),
  ("read_only_space", 0x06025): (111, "ScriptMap"),
  ("read_only_space", 0x0604d): (112, "ScriptOrModuleMap"),
  ("read_only_space", 0x06075): (113, "SourceTextModuleInfoEntryMap"),
  ("read_only_space", 0x0609d): (114, "StackFrameInfoMap"),
  ("read_only_space", 0x060c5): (115, "TemplateObjectDescriptionMap"),
  ("read_only_space", 0x060ed): (116, "Tuple2Map"),
  ("read_only_space", 0x06115): (117, "WasmContinuationObjectMap"),
  ("read_only_space", 0x0613d): (118, "WasmExceptionTagMap"),
  ("read_only_space", 0x06165): (119, "WasmIndirectFunctionTableMap"),
  ("read_only_space", 0x0618d): (137, "SloppyArgumentsElementsMap"),
  ("read_only_space", 0x061b5): (154, "DescriptorArrayMap"),
  ("read_only_space", 0x061dd): (159, "UncompiledDataWithoutPreparseDataMap"),
  ("read_only_space", 0x06205): (158, "UncompiledDataWithPreparseDataMap"),
  ("read_only_space", 0x0622d): (176, "OnHeapBasicBlockProfilerDataMap"),
  ("read_only_space", 0x06255): (172, "InternalClassMap"),
  ("read_only_space", 0x0627d): (183, "SmiPairMap"),
  ("read_only_space", 0x062a5): (182, "SmiBoxMap"),
  ("read_only_space", 0x062cd): (148, "ExportedSubClassBaseMap"),
  ("read_only_space", 0x062f5): (149, "ExportedSubClassMap"),
  ("read_only_space", 0x0631d): (68, "AbstractInternalClassSubclass1Map"),
  ("read_only_space", 0x06345): (69, "AbstractInternalClassSubclass2Map"),
  ("read_only_space", 0x0636d): (136, "InternalClassWithSmiElementsMap"),
  ("read_only_space", 0x06395): (173, "InternalClassWithStructElementsMap"),
  ("read_only_space", 0x063bd): (150, "ExportedSubClass2Map"),
  ("read_only_space", 0x063e5): (184, "SortStateMap"),
  ("read_only_space", 0x0640d): (162, "CallRefDataMap"),
  ("read_only_space", 0x06435): (90, "AllocationSiteWithWeakNextMap"),
  ("read_only_space", 0x0645d): (90, "AllocationSiteWithoutWeakNextMap"),
  ("read_only_space", 0x06485): (81, "LoadHandler1Map"),
  ("read_only_space", 0x064ad): (81, "LoadHandler2Map"),
  ("read_only_space", 0x064d5): (81, "LoadHandler3Map"),
  ("read_only_space", 0x064fd): (82, "StoreHandler0Map"),
  ("read_only_space", 0x06525): (82, "StoreHandler1Map"),
  ("read_only_space", 0x0654d): (82, "StoreHandler2Map"),
  ("read_only_space", 0x06575): (82, "StoreHandler3Map"),
  ("map_space", 0x02119): (1057, "ExternalMap"),
  ("map_space", 0x02141): (2114, "JSMessageObjectMap"),
}

# List of known V8 objects.
KNOWN_OBJECTS = {
  ("read_only_space", 0x021b9): "EmptyWeakFixedArray",
  ("read_only_space", 0x021c1): "EmptyDescriptorArray",
  ("read_only_space", 0x021f9): "EmptyEnumCache",
  ("read_only_space", 0x0222d): "EmptyFixedArray",
  ("read_only_space", 0x02235): "NullValue",
  ("read_only_space", 0x0233d): "UninitializedValue",
  ("read_only_space", 0x023b5): "UndefinedValue",
  ("read_only_space", 0x023f9): "NanValue",
  ("read_only_space", 0x0242d): "TheHoleValue",
  ("read_only_space", 0x02459): "HoleNanValue",
  ("read_only_space", 0x0248d): "TrueValue",
  ("read_only_space", 0x024cd): "FalseValue",
  ("read_only_space", 0x024fd): "empty_string",
  ("read_only_space", 0x02739): "EmptyScopeInfo",
  ("read_only_space", 0x02771): "ArgumentsMarker",
  ("read_only_space", 0x027d1): "Exception",
  ("read_only_space", 0x0282d): "TerminationException",
  ("read_only_space", 0x02895): "OptimizedOut",
  ("read_only_space", 0x028f5): "StaleRegister",
  ("read_only_space", 0x0323d): "EmptyPropertyArray",
  ("read_only_space", 0x03245): "EmptyByteArray",
  ("read_only_space", 0x0324d): "EmptyObjectBoilerplateDescription",
  ("read_only_space", 0x03281): "EmptyArrayBoilerplateDescription",
  ("read_only_space", 0x0328d): "EmptyClosureFeedbackCellArray",
  ("read_only_space", 0x03295): "EmptySlowElementDictionary",
  ("read_only_space", 0x032b9): "EmptyOrderedHashMap",
  ("read_only_space", 0x032cd): "EmptyOrderedHashSet",
  ("read_only_space", 0x032e1): "EmptyFeedbackMetadata",
  ("read_only_space", 0x032ed): "EmptyPropertyDictionary",
  ("read_only_space", 0x03315): "EmptyOrderedPropertyDictionary",
  ("read_only_space", 0x0332d): "EmptySwissPropertyDictionary",
  ("read_only_space", 0x03381): "NoOpInterceptorInfo",
  ("read_only_space", 0x033a9): "EmptyWeakArrayList",
  ("read_only_space", 0x033b5): "InfinityValue",
  ("read_only_space", 0x033c1): "MinusZeroValue",
  ("read_only_space", 0x033cd): "MinusInfinityValue",
  ("read_only_space", 0x033d9): "SelfReferenceMarker",
  ("read_only_space", 0x03419): "BasicBlockCountersMarker",
  ("read_only_space", 0x0345d): "OffHeapTrampolineRelocationInfo",
  ("read_only_space", 0x03469): "TrampolineTrivialCodeDataContainer",
  ("read_only_space", 0x03475): "TrampolinePromiseRejectionCodeDataContainer",
  ("read_only_space", 0x03481): "GlobalThisBindingScopeInfo",
  ("read_only_space", 0x034b1): "EmptyFunctionScopeInfo",
  ("read_only_space", 0x034d5): "NativeScopeInfo",
  ("read_only_space", 0x034ed): "HashSeed",
  ("old_space", 0x04211): "ArgumentsIteratorAccessor",
  ("old_space", 0x04255): "ArrayLengthAccessor",
  ("old_space", 0x04299): "BoundFunctionLengthAccessor",
  ("old_space", 0x042dd): "BoundFunctionNameAccessor",
  ("old_space", 0x04321): "ErrorStackAccessor",
  ("old_space", 0x04365): "FunctionArgumentsAccessor",
  ("old_space", 0x043a9): "FunctionCallerAccessor",
  ("old_space", 0x043ed): "FunctionNameAccessor",
  ("old_space", 0x04431): "FunctionLengthAccessor",
  ("old_space", 0x04475): "FunctionPrototypeAccessor",
  ("old_space", 0x044b9): "StringLengthAccessor",
  ("old_space", 0x044fd): "InvalidPrototypeValidityCell",
  ("old_space", 0x04505): "EmptyScript",
  ("old_space", 0x04545): "ManyClosuresCell",
  ("old_space", 0x04551): "ArrayConstructorProtector",
  ("old_space", 0x04565): "NoElementsProtector",
  ("old_space", 0x04579): "MegaDOMProtector",
  ("old_space", 0x0458d): "IsConcatSpreadableProtector",
  ("old_space", 0x045a1): "ArraySpeciesProtector",
  ("old_space", 0x045b5): "TypedArraySpeciesProtector",
  ("old_space", 0x045c9): "PromiseSpeciesProtector",
  ("old_space", 0x045dd): "RegExpSpeciesProtector",
  ("old_space", 0x045f1): "StringLengthProtector",
  ("old_space", 0x04605): "ArrayIteratorProtector",
  ("old_space", 0x04619): "ArrayBufferDetachingProtector",
  ("old_space", 0x0462d): "PromiseHookProtector",
  ("old_space", 0x04641): "PromiseResolveProtector",
  ("old_space", 0x04655): "MapIteratorProtector",
  ("old_space", 0x04669): "PromiseThenProtector",
  ("old_space", 0x0467d): "SetIteratorProtector",
  ("old_space", 0x04691): "StringIteratorProtector",
  ("old_space", 0x046a5): "SingleCharacterStringCache",
  ("old_space", 0x04aad): "StringSplitCache",
  ("old_space", 0x04eb5): "RegExpMultipleCache",
  ("old_space", 0x052bd): "BuiltinsConstantsTable",
  ("old_space", 0x056e5): "AsyncFunctionAwaitRejectSharedFun",
  ("old_space", 0x05709): "AsyncFunctionAwaitResolveSharedFun",
  ("old_space", 0x0572d): "AsyncGeneratorAwaitRejectSharedFun",
  ("old_space", 0x05751): "AsyncGeneratorAwaitResolveSharedFun",
  ("old_space", 0x05775): "AsyncGeneratorYieldResolveSharedFun",
  ("old_space", 0x05799): "AsyncGeneratorReturnResolveSharedFun",
  ("old_space", 0x057bd): "AsyncGeneratorReturnClosedRejectSharedFun",
  ("old_space", 0x057e1): "AsyncGeneratorReturnClosedResolveSharedFun",
  ("old_space", 0x05805): "AsyncIteratorValueUnwrapSharedFun",
  ("old_space", 0x05829): "PromiseAllResolveElementSharedFun",
  ("old_space", 0x0584d): "PromiseAllSettledResolveElementSharedFun",
  ("old_space", 0x05871): "PromiseAllSettledRejectElementSharedFun",
  ("old_space", 0x05895): "PromiseAnyRejectElementSharedFun",
  ("old_space", 0x058b9): "PromiseCapabilityDefaultRejectSharedFun",
  ("old_space", 0x058dd): "PromiseCapabilityDefaultResolveSharedFun",
  ("old_space", 0x05901): "PromiseCatchFinallySharedFun",
  ("old_space", 0x05925): "PromiseGetCapabilitiesExecutorSharedFun",
  ("old_space", 0x05949): "PromiseThenFinallySharedFun",
  ("old_space", 0x0596d): "PromiseThrowerFinallySharedFun",
  ("old_space", 0x05991): "PromiseValueThunkFinallySharedFun",
  ("old_space", 0x059b5): "ProxyRevokeSharedFun",
}

# Lower 32 bits of first page addresses for various heap spaces.
HEAP_FIRST_PAGES = {
  0x080c0000: "old_space",
  0x08100000: "map_space",
  0x08000000: "read_only_space",
}

# List of known V8 Frame Markers.
FRAME_MARKERS = (
  "ENTRY",
  "CONSTRUCT_ENTRY",
  "EXIT",
  "WASM",
  "WASM_TO_JS",
  "JS_TO_WASM",
  "WASM_DEBUG_BREAK",
  "C_WASM_ENTRY",
  "WASM_EXIT",
  "WASM_COMPILE_LAZY",
  "INTERPRETED",
  "BASELINE",
  "OPTIMIZED",
  "STUB",
  "BUILTIN_CONTINUATION",
  "JAVA_SCRIPT_BUILTIN_CONTINUATION",
  "JAVA_SCRIPT_BUILTIN_CONTINUATION_WITH_CATCH",
  "INTERNAL",
  "CONSTRUCT",
  "BUILTIN",
  "BUILTIN_EXIT",
  "NATIVE",
)

# This set of constants is generated from a shipping build.
